#! /usr/bin/env python
"""Standalone script to convert old-style ddiags file to new-style
compl_file"""

from tfit import sextutils
from tfit.applydance import parserange
import numpy as N
import sys

def main(infile,outfile=None):
    if outfile is None:
        outfile=infile.replace('.txt','_compl.txt')

    #Read in the old file
    cat=sextutils.rw_catalog(infile)

    #Define the new columns
    cat.addemptycolumn('lx',N.int32)
    cat.addemptycolumn('ly',N.int32)
    cat.addemptycolumn('uy',N.int32)
    cat.addemptycolumn('ux',N.int32)

    #Fill the new columns
    for k in cat:
      lx,ux,ly,uy=parserange(cat.range[k])
      cat.lx[k]=lx
      cat.ly[k]=ly
      cat.ux[k]=ux
      cat.uy[k]=uy
   
    #Write the resulting file
    cat.writeto(outfile)

if __name__ == '__main__':
    try:
        inname=sys.argv[1]
        if len(sys.argv) > 2:
            outname=sys.argv[2]
        main(inname,outname)
    except Exception,e:
        print "Usage: ddiags_to_complfile.py inname [outname]"
        raise(e)
