#! /usr/bin/env python
from tfit import tfit_diags,fitsimage, futil, sextutils
import sys


def main(tdir,loresfile,bestfile=None):
    """ Make a collage. If a bestfile is supplied, drive the collage from
    it, and apply the scale factor it contains. If not, drive the collage
    from the template directory. """
    if bestfile:
        sf=readbest(bestfile)
    lores=fitsimage.Image(loresfile)
    coll=tfit_diags.collage(lores.d.shape,tdir,bigwcs=lores.wcs,mult=sf)
    futil.writeimage(coll,'collage.fits',header=lores.h)

def readbest(bestfile):
    """ read the scale factor from the already-created bestfile"""
    cat=sextutils.se_catalog(bestfile)
    d={}
    for k in cat:
        d[str(cat.objectid[k])]=cat.fitqty[k]
    return d

if __name__ == '__main__':
    tdir,loresfile=sys.argv[1:3]
    if len(sys.argv) == 4:
        bestfile=sys.argv[3]
    else:
        bestfile=None
    main(tdir,loresfile,bestfile=bestfile)
