import random
import pyfits
import numarray as N
import numarray.random_array as ra
import futil

def gendata(mu, sigma,shape):
    """ generate some data at a given mean with a given sigma
    History:
    20 June 05: Updated to use numarray.random_array: faster & more accurate"""
    ans=ra.normal(mu,sigma,shape)
    return ans

def writeconstrms(rms,shape,sourcename,fname,type='Float32'):
    """ write an rms map with a constant rms """
    d=N.ones(shape,type)*rms
    f=pyfits.open(sourcename)
    f[0].data=d
    f.writeto(fname)

    

def writenoise(mu,rms,shape,sourcename,fname):
    """ write a noise image generated from constant rms """
    
    d=gendata(mu,rms,shape)
    f=pyfits.open(sourcename)
    f[0].data=d
    f.writeto(fname)


def makemany(num,mu,rms,shape,namepattern,sourcename):
    for i in range(1,num+1):
        fname=namepattern%(i,"noise")
        writenoise(mu,rms,shape,sourcename,fname)
        fname=namepattern%(i,"rms")
        writeconstrms(rms,shape,sourcename,fname)
        
