#! /usr/bin/env python
from tfit import covar_proc, catutils
import sys
import pyfits
import glob


def get_covar_from_fits(fname):
    f=pyfits.open(fname)
    cell=covar_proc.covarcell(f[0].header['cellid'],
                              f[1].data.field('object'),
                              f[0].data)
    f.close()
    return cell

def build_covar_dict(dirname):
    flist=glob.glob(dirname+'/*.fits')
    cdict={}
    for fname in flist:
        tmp=get_covar_from_fits(fname)
        cdict[tmp.id]=tmp
    return cdict
            
if __name__ == '__main__':
    catname, covardir = sys.argv[1:]
    cat=catutils.tfit_catalog(catname)
    cdict=build_covar_dict(covardir)
    cat.addcovar(cdict)
    cat.writeto(catname+'_plus_covar')
