from tfit.pipeline import Stage, Pipeline

def StageFactory(StageName, d):

    StageName = StageName.lower()
    if StageName == 'add':
        args=(d['a1'],d['a2'])
        return Stage(StageName,
                     add,
                     *args)

    if StageName == 'multiply':
        args=(d['p1'],d['p2'])
        return Stage(StageName,
                     multiply,
                     *args)

    if StageName == 'divide':
        args=(d['d1'],d['d2'])
        return Stage(StageName,
                     divide,
                     *args)


    #If we get here, stage is undefined
    print "Sorry, %s stage has not yet been defined"%StageName
    return
    
#................................................
#in a real pipeline, these would be imported from elsewhere and
# just referenced
def add(a1,a2):
    return a1+a2

def multiply(p1,p2):
    return p1*p2

def divide(d1,d2):
    return d1/d2

#.................................................
def demo(catch=False):

    d={ 'a1': 5, 'a2': 7,
        'p1': 6, 'p2': 4,
        'd1': 42, 'd2': 0,
        'order': ['add', 'multiply', 'divide','add'] }

    pipe=Pipeline('test pipeline',catch=catch)
    for stagename in d['order']:
        pipe.append(StageFactory(stagename,d))

    sep = '------------------------------------------------------\n'
    print sep,"Demonstrating pipe.show():\n",sep
    pipe.show()
    print sep,"Demonstrating pipe.run(): \n",sep
    try:
        pipe.run()
    except:
        pass
    print sep,"Demonstrating pipe.status(): \n",sep
    pipe.status()
    print sep,"Demonstrating pipe.answers(): \n",sep
    pipe.answers()
