#! /usr/bin/env python
import types
from tfit import pipeline, tfit_stages, parseconfig
from tfit import __version__ as tfversion

__version__ = '1.0'
__vdate__ = '2007-12-18'

def run(parfile):
    #Display versions
    print "Version %s of TFIT package"%tfversion
    
    #read param file
    d=parseconfig.main(parfile,{})

    #Construct the pipeline
    pipe=pipeline.Pipeline(parfile)
    
    #Catch for single-stage pipelines
    if type(d['order']) == types.StringType:
        d['order'] = [d['order']]
        
    for sname in d['order']:
        pipe.append(tfit_stages.StageFactory(sname,d))

    #Display & run the pipeline
    pipe.show()
    pipe.run()
    pipe.answers()


if __name__ == '__main__':
    import sys
    parfile=sys.argv[1]
    run(parfile)
