class BadAnswer(ValueError):
    """ Calculation produced wrong answer """

def testwcs(newwcs):
    """ Require crpix1/2 to be at half-pixels """

    if not newwcs.crpix1%1 or not newwcs.crpix2%1:
	raise BadAnswer, \
	  "Bad crpix: no integers allowed: %f %f " % (newwcs.crpix1, newwcs.crpix2)
    elif newwcs.crpix1%.5 or newwcs.crpix2%.5:
	raise BadAnswer, \
	      "Bad crpix: must be half pixel: %f %f " % (newwcs.crpix1, newwcs.crpix2)

def testbox(hnew,scale):
    """test to make sure that this box matches up with coarser grid """
    #If these conditions are violated, it *cannot* be right
    if hnew.Xdim()%scale:
	raise BadAnswer,"Xdim not divisible by scale: %f"%hnew.Xdim()
    if hnew.Ydim()%scale:
	raise BadAnswer,"Ydim not divisible by scale: %f"%hnew.Ydim()

    #If these conditions are met, it *is* right.
    if (hnew.lx-1)%scale:
	raise BadAnswer,"lx-1 not divisible by scale: %f"%(hnew.lx-1)
    if (hnew.ly-1)%scale:
	raise BadAnswer,"ly-1 not divisible by scale: %f"%(hnew.ly-1)
