#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "fitsio.h"
#include "nrutil.h"
#include "define.h"
#include "box.h"
#include "fits.h"
#include "fitsmanip.h"

/* ------------------------------------------------------------------
   The *fitsio* software for reading/writing/manipulating FITS images
   will not overwrite a file unless the filename is preceded by a '!'.
   THIS ALGORITHM CHECKS TO SEE IF THE FIRST CHARACTER IS '!' --
   IF NOT -- IT INSERT'S ONE -- PREVIOUS FILES WILL BE OVERWRITTEN!
   ------------------------------------------------------------------
*/

void FitsManip::WriteFits(Fits *Image,char imagefile[], int *status) {
  fitsfile *ffile;
  char temp[STRING_LENGTH] = "!";
  char oldname[STRING_LENGTH];
  strcpy(oldname,imagefile);
  if (imagefile[0] != '!') {
    strcat(temp,imagefile);
    strcpy(imagefile,temp);
  }
  long naxes[2] = {Image->xsize,Image->ysize};
  fits_create_file(&ffile,imagefile, status);
  switch(Image->PixType) {
  case TINT :
    fits_create_img(ffile,SHORT_IMG,2,naxes,status);
    fits_write_img(ffile,Image->PixType,FIRSTPIXEL,Image->xsize*Image->ysize,
		   Image->idata[0],status);
    break;
  case TFLOAT :
    fits_create_img(ffile,FLOAT_IMG,2,naxes,status);
    fits_write_img(ffile,Image->PixType,FIRSTPIXEL,Image->xsize*Image->ysize,
		   Image->data[0],status);
    break;
  default:
    cout << "Undefined PIXTYPE in Fits: " << Image->Title() << endl;
    return;
  }
  fits_close_file(ffile,status);
  fits_report_error(stderr,*status);
  cout << "Wrote " << Image->Title() << " to " << oldname << endl;
}
