#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "fitsio.h"
#include "nrutil.h"
#include "define.h"
#include "fits.h"
#include "structs.h"
#include "par.h"
#include "fitsmanip.h"
#include "funcs.h"

void Funcs::setBounds(int *bxlo, int *bxhi, int *bylo, int *byhi, Fits *F,
		      int obj, float xc, float yc, int FrameSize) {

  int xpos = F->rnd(xc), ypos = F->rnd(yc), i,j;
  int xbuffer=20,ybuffer=20;
  int xlo=xpos-xbuffer,xhi=xpos+xbuffer,ylo=ypos-ybuffer,yhi=ypos+ybuffer;
  int pxlo=xlo,pxhi=xhi,pylo=ylo,pyhi=yhi;

  if (F->PixType != TINT) {
    cout << "Warning:  setBounds() must be passed an image with integer pixels" << endl;
    assert(F->PixType == TINT);
  }

  while ((xpos+xbuffer==xhi) || (xpos-xbuffer==xlo) || (ypos-ybuffer==ylo) 
	 || (ypos+ybuffer==yhi)) {
    xbuffer *= 2;
    ybuffer *= 2;
    pxlo = xpos-xbuffer > F->xmin ? xpos-xbuffer : F->xmin;
    pxhi = xpos+xbuffer < F->xmax ? xpos+xbuffer : F->xmax;
    pylo = ypos-ybuffer > F->ymin ? ypos-ybuffer : F->ymin;
    pyhi = ypos+ybuffer < F->ymax ? ypos+ybuffer : F->ymax;
    for (i = pxlo; i<=pxhi; i++) 
      for (j = pylo; j<=pyhi; j++) {
	if (F->idata[j][i] == obj) {
	  if (j > yhi) yhi = j;
	  if (j < ylo) ylo = j;
	  if (i < xlo) xlo = i;
	  if (i > xhi) xhi = i;
	}
      }
  }

  *bxlo = xlo - FrameSize;
  *bylo = ylo - FrameSize;
  *bxhi = xhi + FrameSize;
  *byhi = yhi + FrameSize;
  *bxlo = *bxlo < F->xmin ? F->xmin : *bxlo;
  *bxhi = *bxhi > F->xmax ? F->xmax : *bxhi;
  *bylo = *bylo < F->ymin ? F->ymin : *bylo;
  *byhi = *byhi > F->ymax ? F->ymax : *byhi;
}
